import { useState } from 'react';
import './App.css';
import output from './data';

const gradeOptions = [
  { grades: 1 },
  { grades: 2 },
  { grades: 3 },
  { grades: 4 },
  { grades: 5 },
  { grades: 6 },
  { grades: 7 },
  { grades: 8 },
  { grades: 9 },
  { grades: 10 }
]

const App = () => {
  const [data, setData] = useState(output);
  const [preview, setPreview] = useState(undefined);

  const handlePreview = () => {
    setPreview({ ...data });
  }

  const handleGradesChange = (student, nthAspect, val) => {
    data[nthAspect][student] = Number(val);
    setData(data);
  }

  return (
    <div className="App">
      <header className="App-header">
        <>
          <table>
            <tr>
              <tr></tr>
              <th style={{ fontSize: 18, width: 200 }}>aspek penilaian 1</th>
              <th style={{ fontSize: 18, width: 200 }}>aspek penilaian 2</th>
              <th style={{ fontSize: 18, width: 200 }}>aspek penilaian 3</th>
              <th style={{ fontSize: 18, width: 200 }}>aspek penilaian 4</th>
            </tr>
            {[...Array(10)].map((_, i) => (
              <tr>
                <td style={{ fontSize: 18 }}>Mahasiswa {i + 1}</td>
                {[...Array(4)].map((_, j) => (
                  <td>
                    <select onChange={(e) => handleGradesChange(`mahasiswa_${i + 1}`, `aspek_penilaian_${j + 1}`, e.target.value)} style={{ width: 50 }}>
                      {gradeOptions.map(x => (
                        <option value={x.grades}>{x.grades}</option>
                      ))
                      }
                    </select>
                  </td>
                ))}
              </tr>
            ))}
          </table>
          <div style={{ display: 'flex' }}>
            <button onClick={() => handlePreview()} id="preview" style={{ marginTop: 20, marginRight: 20 }}>Preview</button>
            <button type="submit" id="save" style={{ marginTop: 20 }}>
              <a
                href={`data:text/json;charset=utf-8,${encodeURIComponent(
                  JSON.stringify(data, null, 4)
                )}`}
                style={{ textDecoration: 'none', color: 'black' }}
                download={'grades.json'}
              >
                Simpan
              </a>
            </button>
          </div>
        </>
        {preview &&
          <pre id="json" style={{ fontSize: 12, width: '100%', textAlign: 'justify' }}>{JSON.stringify(data, null, 4)}</pre>
        }
      </header>
    </div>
  );
}

export default App;
